#!perl -w

use 5.008;
use ExtUtils::MakeMaker;
use Cwd;
use File::Spec;
use ExtUtils::Depends;
use ExtUtils::PkgConfig;
use Gtk2::CodeGen;

mkdir 'build', 0777;

$renderer = ExtUtils::Depends->new ('Gtk2::CellRenderer::Base', 'Gtk2', 'Glib');
$renderer->add_c ("gtk2perl_cell_renderer_base.c");
$renderer->add_xs ("Base.xs");
$renderer->add_pm ('Base.pm' => '$(INST_LIBDIR)/Base.pm');
my $cwd = cwd();
#$renderer->add_typemaps (map {File::Spec->catfile($cwd,$_)} 'build/trayicon.typemap');

# $renderer->add_headers ('trayicon.h');
# $renderer->install (qw(trayicon.h build/trayicon-autogen.h));

#$renderer->install (qw(build/trayicon-autogen.h));
$renderer->save_config ('build/IFiles.pm');

WriteMakefile(
    NAME            => 'Gtk2::CellRenderer::Base',
    VERSION_FROM    => 'Base.pm', # finds $VERSION
    ABSTRACT_FROM   => 'Base.pm', # retrieve abstract from module
    XSPROTOARG      => '-noprototypes',
    $renderer->get_makefile_vars,
    PREREQ_PM       =>  {
    	Gtk2 => 1.00,
    },
);

package MY;

sub postamble
{
	"
realclean ::
	-rm -Rf build
"
}
package MAIN;
# gcc -I. `pkg-config --cflags gtk+-2.0` `pkg-config --libs gtk+-2.0` -DEGG_COMPILATION -DGTK_DISABLE_DEPRECATED -DGDK_DISABLE_DEPRECATED -DG_DISABLE_DEPRECATED -g -O2 -Wall --shared eggtrayicon.c -o eggtrayicon.o
