#include "gtk2perl_cell_renderer_base.h"
#include <gtk2perl.h>

#define newSVGdkRectangle_ornull(r)	\
	((r) ? newSVGdkRectangle(r) : newSVsv (&PL_sv_undef))
#define newSVGdkEvent_ornull(e)	\
	((e) ? newSVGdkEvent(e) : newSVsv (&PL_sv_undef))
#define newSVGChar_ornull(s)	\
	((s) ? newSVGChar(s) : newSVsv (&PL_sv_undef))

static void gtk2perl_cell_renderer_base_class_init
                                      (Gtk2PerlCellRendererBaseClass * class);
static void gtk2perl_cell_renderer_base_get_size
                                      (GtkCellRenderer      * cell,
				       GtkWidget            * widget,
				       GdkRectangle         * cell_area,
				       gint                 * x_offset,
				       gint                 * y_offset,
				       gint                 * width,
				       gint                 * height);
static void gtk2perl_cell_renderer_base_render
                                      (GtkCellRenderer      * cell,
				       GdkWindow            * window,
				       GtkWidget            * widget,
				       GdkRectangle         * background_area,
				       GdkRectangle         * cell_area,
				       GdkRectangle         * expose_area,
				       GtkCellRendererState   flags);
static gboolean gtk2perl_cell_renderer_base_activate
                                      (GtkCellRenderer      * cell,
				       GdkEvent             * event,
				       GtkWidget            * widget,
				       const gchar          * path,
				       GdkRectangle         * background_area,
				       GdkRectangle         * cell_area,
				       GtkCellRendererState   flags);
static GtkCellEditable * gtk2perl_cell_renderer_base_start_editing
                                      (GtkCellRenderer      * cell,
				       GdkEvent             * event,
				       GtkWidget            * widget,
				       const gchar          * path,
				       GdkRectangle         * background_area,
				       GdkRectangle         * cell_area,
				       GtkCellRendererState   flags);

static GtkCellRendererClass * parent_class = NULL;

GType
gtk2perl_cell_renderer_base_get_type (void)
{
	static GType cell_type = 0;

	if (!cell_type) {
		static const GTypeInfo cell_info = {
			sizeof (GtkCellRendererClass),
			NULL,		/* base_init */
			NULL,		/* base_finalize */
			(GClassInitFunc) gtk2perl_cell_renderer_base_class_init,
			NULL,		/* class_finalize */
			NULL,		/* class_data */
			sizeof (GtkCellRenderer),
			0,		/* n_preallocs */
			NULL,		/* instance_init */
			NULL,		/* value_table */
		};

		cell_type = g_type_register_static (GTK_TYPE_CELL_RENDERER,
		                                    "Gtk2PerlCellRendererBase", 
		                                    &cell_info, 0);
	}

	return cell_type;
}

static void
gtk2perl_cell_renderer_base_class_init (Gtk2PerlCellRendererBaseClass * class)
{
	GtkCellRendererClass * cell_renderer_class =
				(GtkCellRendererClass*) class;

	parent_class = g_type_class_peek_parent (class);

	cell_renderer_class->get_size = gtk2perl_cell_renderer_base_get_size;
	cell_renderer_class->render = gtk2perl_cell_renderer_base_render;
	cell_renderer_class->activate = gtk2perl_cell_renderer_base_activate;
	cell_renderer_class->start_editing = gtk2perl_cell_renderer_base_start_editing;
}

static void
gtk2perl_cell_renderer_base_get_size (GtkCellRenderer      * cell,
				      GtkWidget            * widget,
				      GdkRectangle         * cell_area,
				      gint                 * x_offset,
				      gint                 * y_offset,
				      gint                 * width,
				      gint                 * height)
{
	int count, i;
	dSP;

	ENTER;
	SAVETMPS;
	PUSHMARK (SP);

	EXTEND (SP, 3);
	PUSHs (newSVGtkCellRenderer (cell));
	PUSHs (newSVGtkWidget (widget));
	PUSHs (sv_2mortal (newSVGdkRectangle_ornull (cell_area)));

	PUTBACK;
	count = call_method ("on_get_size", G_ARRAY);
	SPAGAIN;
	if (count != 4)
		croak ("on_get_size must return four values -- the x_offset, x_offset, width, and height");

	i = POPi;  if (height)   *height   = i;
	i = POPi;  if (width)    *width    = i;
	i = POPi;  if (y_offset) *y_offset = i;
	i = POPi;  if (x_offset) *x_offset = i;

	PUTBACK;
	FREETMPS;
	LEAVE;
}

static void
gtk2perl_cell_renderer_base_render (GtkCellRenderer      * cell,
				    GdkWindow            * window,
				    GtkWidget            * widget,
				    GdkRectangle         * background_area,
				    GdkRectangle         * cell_area,
				    GdkRectangle         * expose_area,
				    GtkCellRendererState   flags)
{
	dSP;

	ENTER;
	SAVETMPS;
	PUSHMARK (SP);

	EXTEND (SP, 7);
	PUSHs (newSVGtkCellRenderer (cell));
	PUSHs (newSVGdkWindow_ornull (window));
	PUSHs (newSVGtkWidget_ornull (widget));
	PUSHs (sv_2mortal (newSVGdkRectangle_ornull (background_area)));
	PUSHs (sv_2mortal (newSVGdkRectangle_ornull (cell_area)));
	PUSHs (sv_2mortal (newSVGdkRectangle_ornull (expose_area)));
	PUSHs (sv_2mortal (newSVGtkCellRendererState (flags)));

	PUTBACK;
	call_method ("on_render", G_VOID|G_DISCARD);

	FREETMPS;
	LEAVE;
}

static gboolean
gtk2perl_cell_renderer_base_activate (GtkCellRenderer      * cell,
				      GdkEvent             * event,
				      GtkWidget            * widget,
				      const gchar          * path,
				      GdkRectangle         * background_area,
				      GdkRectangle         * cell_area,
				      GtkCellRendererState   flags)
{
	gboolean retval;
	g_printerr ("activate : %s(%p) on %s(%p)\n",
		    G_OBJECT_TYPE_NAME (cell), cell,
		    G_OBJECT_TYPE_NAME (widget), widget);

	dSP;

	ENTER;
	SAVETMPS;
	PUSHMARK (SP);

	XPUSHs (newSVGtkCellRenderer (cell));
	XPUSHs (sv_2mortal (newSVGdkEvent_ornull (event)));
	XPUSHs (newSVGtkWidget_ornull (widget));
	XPUSHs (sv_2mortal (newSVGChar_ornull (path)));
	XPUSHs (sv_2mortal (newSVGdkRectangle_ornull (background_area)));
	XPUSHs (sv_2mortal (newSVGdkRectangle_ornull (cell_area)));
	XPUSHs (sv_2mortal (newSVGtkCellRendererState (flags)));

	PUTBACK;
	call_method ("on_render", G_SCALAR|G_DISCARD);
	SPAGAIN;

	retval = POPi;

	FREETMPS;
	LEAVE;

	return retval;
}

static GtkCellEditable *
gtk2perl_cell_renderer_base_start_editing (GtkCellRenderer * cell,
					   GdkEvent        * event,
					   GtkWidget       * widget,
					   const gchar     * path,
					   GdkRectangle    * background_area,
					   GdkRectangle    * cell_area,
					   GtkCellRendererState   flags)
{
	GtkCellEditable * editable;
	SV * sv;

	g_printerr ("start_editing : %s(%p) on %s(%p)\n",
		    G_OBJECT_TYPE_NAME (cell), cell,
		    G_OBJECT_TYPE_NAME (widget), widget);

	dSP;

	ENTER;
	SAVETMPS;
	PUSHMARK (SP);

	EXTEND (SP, 7);
	PUSHs (newSVGtkCellRenderer (cell));
	PUSHs (sv_2mortal (newSVGdkEvent_ornull (event)));
	PUSHs (newSVGtkWidget_ornull (widget));
	PUSHs (sv_2mortal (newSVGChar_ornull (path)));
	PUSHs (sv_2mortal (newSVGdkRectangle_ornull (background_area)));
	PUSHs (sv_2mortal (newSVGdkRectangle_ornull (cell_area)));
	PUSHs (sv_2mortal (newSVGtkCellRendererState (flags)));

	PUTBACK;
	call_method ("on_start_editing", G_SCALAR);
	SPAGAIN;

	sv = POPs;
	editable = SvGtkCellEditable_ornull (sv);

	FREETMPS;
	LEAVE;

	return editable;
}

